dojo.require("dojo.cookie");

//	set up the stylesheet switching mechanism
dojo.addOnLoad(function(){
	var switcher=function(evt){
		var li=dojo.query("head link[title='" + evt.target.getAttribute("title") + "']")[0];
		dojo.query("head link[title]").forEach(function(item){
			if(item.getAttribute("title")==li.getAttribute("title")){
				sheet=item.getAttribute("title");
				dojo.query("#stylesheet-block ul li[title='"+item.getAttribute("title")+"']")[0].className="selected";
				item.disabled=false;
			} else {
				dojo.query("#stylesheet-block ul li[title='"+item.getAttribute("title")+"']")[0].className="";
				item.disabled=true;
			}
		});
		dojo.cookie(c, sheet, { expires: 14 });
	}

	//	grab any cookies to set the sheet initially
	var c="apiStyle";
	var sheet=dojo.cookie(c) || "Noir";//	default

	//	initialize the stylesheet switcher
	var sb=dojo.query("#stylesheet-block"), ul, nl=dojo.query("head link[title]");
	nl.forEach(function(item){
		item.disabled=false;
		var title=item.getAttribute("title");
		if(!ul){
			ul=document.createElement("ul");
			sb.adopt(ul, "first");
		}
		var li=document.createElement("li");
		li.innerHTML=title;
		li.setAttribute("title", title);
		if(title==sheet){
			li.className="selected";
		} else {
			item.disabled=true;
		}
		ul.appendChild(li);
		dojo.connect(li, "onclick", switcher);
	});

	//	TODO: There has got to be a better way of doing this.
	//	for some reason, safari 3 doesn't like to show the stylesheet that's not first in the doc.  So we force it.
	if(dojo.isSafari){
		dojo.query("head link[title]")
			.filter(function(item){ return !item.disabled; })
			.forEach(function(item){
				item.disabled=!item.disabled;
				item.disabled=!item.disabled;
			});
	}
});

//	set up toggle switches
dojo.addOnLoad(function(){
	var inh=true;
	var pvt=false;	//	state of Private vars, false is default
	var m=dojo.byId("main-block"), n=dojo.byId("toggle-switches");

	function sp(cl, state){
		var s=document.createElement("span");
		s.id="toggle-"+cl;
		s.className="toggle-switch";
		s.innerHTML= (state?"Hide ":"Show ") + cl + " members";
		s.style.cursor="pointer";
		n.appendChild(s);
		return s;
	}

	function hide(cl){
		dojo.byId("toggle-"+cl).innerHTML="Show "+ cl + " members";
		dojo.query("div."+cl, m).style("display", "none");
	}

	function toggleMessage(type){
		var nl=dojo.query(".jsdoc-field-type-" + type + " .jsdoc-field");
		var display="none";
		if(nl.length==0){ display="block"; }
		var nf=dojo.query(".no-fields-" + type)
		if(nf.length>0){ nf.style("display", display); }
	}

	var types=[ "namespaces", "constructors", "functions", "properties" ];	

	//	inherited first
	var b=false;	//	if we should display the switches node at all.
	var nl=dojo.query("div.inherited", m);
	if(nl.length>0){
		//	set up the span
		var s=sp("inherited", inh);
		dojo.connect(s, "onclick", function(){
			inh=!inh;
			dojo.byId("toggle-inherited").innerHTML=(inh?"Hide ":"Show ")+"inherited members";
			var l=dojo.query("div.inherited", m);
			if(!pvt){ l=l.filter("div:not(.private)"); }
			l.forEach(function(item){
				var d="none";
				if(inh){ d=""; }
				item.style.display=d;
			});

			dojo.forEach(types, toggleMessage);
		});
		b=true;
	}

	nl=dojo.query("div.private", m);
	if(nl.length>0){
		var s=sp("private", pvt);
		dojo.connect(s, "onclick", function(){
			pvt=!pvt;
			dojo.byId("toggle-private").innerHTML=(pvt?"Hide ":"Show ")+"private members";
			var l=dojo.query("div.private", m);
			if(!inh){ l=l.filter("div:not(.inherited)"); }
			l.forEach(function(item){
				var d="none";
				if(pvt){ d=""; }
				item.style.display=d;
			});

			dojo.forEach(types, toggleMessage);
		});
		hide("private");
		b=true;

		var l=dojo.query("div.private", m);
		if(!inh){ l=l.filter("div:not(.inherited)"); }
		l.forEach(function(item){
			var d="none";
			if(pvt){ d=""; }
			item.style.display=d;
		});

		dojo.forEach(types, toggleMessage);
	}
	
	if(b) n.style.display="";
});

//	function view-source, if available
dojo.addOnLoad(function(){
	dojo.query("span.view-source", dojo.byId("main-block")).connect("onclick", function(e){
		var b=false;
		dojo.query("pre.function-source", dojo.byId("main-block")).forEach(function(node){
			if(node.style.display=="none"){
				node.style.display="block";
				b=true;
			} else node.style.display="none";
		});
		if(b) e.target.innerHTML="(hide source)";
		else e.target.innerHTML="(view source)";
	});
});
