if(parent) {
	if(parent.console) {
		parent.console.log("content loaded into child window: " + window.location.href);
	}
	if(parent.runtime) {
		window.runtime = parent.runtime;
	}
}

var loadExternalURL = function(url) {
	if(window.runtime) {
		var request = 	new window.runtime.flash.net.URLRequest(url);
		window.runtime.flash.net.navigateToURL(request, "external");
	} else {
		window.open(url, "external");
	}
};
var clickHandler = function(evt) {
	var elm = evt.target
	while(elm.nodeType==1) {
		// find any ancestor <a> element
		if(elm.tagName == "A") {
			if(elm.className.indexOf("external") > -1) {
				// and treat as external links if they have "external" in their className
				loadExternalURL(elm.href);
				evt.preventDefault();
			} else {
				// go ahead and let it load
			}
			break;
		}
		elm = elm.parentNode;
	}
}


function byId(id) {
	return document.getElementById(id); 
};

function updateHeader(text) {
	var elm = byId("header"); 
	if(elm) {
		elm.innerHTML = text; 
	}
}

function addResultLine(item) {
	var resultElm = byId("search-results");
	if(resultElm) {
		var listItem = document.createElement("li");
		var link = document.createElement("A");
		listItem.appendChild(link);
		link.href = "api/api/" + item.filename;
		link.innerHTML = item.title + "::: " + "api/api/" + item.filename;

		resultElm.appendChild(listItem);
	}
}


// expose some stuff from the child to make available to the parent
window.childSandboxBridge = {
	location: location.href, 
	title: document.title,
	resultTester: "TestTestTestTest",
	updateHeader: updateHeader,
	addResultLine: addResultLine, 
	testMe: function() { alert("testME"); }
};


window.onload = function() {
	document.body.addEventListener('click',clickHandler, false);
}

parentSandboxBridge.onChildLoad({ 
	contentWindow: window,  
	bridge: childSandboxBridge, 
	location: location.href
});

