// Stub fileUtil that delegates to the parentSandboxBridge.

// The following doesn't work because of restrictions on what
// you can send across the sandbox bridge.
// var fileUtil = window.parentSandboxBridge.fileUtil;
// That means that functions need to be put directly into the
// sandbox bridge to work.

var fileUtil = {
	bridgeKeys : ["fileExists", "getFileWriter", "readFile", "saveFile", 
				  "deleteFile", "getLineSeparator", "mkdir", "mkdirs",
				  "getParent", "copyDir", "saveUtf8File", 
				  "getFilteredFileList", "getAbsolutePath"]
};

for(var i in fileUtil.bridgeKeys){
	var key = fileUtil.bridgeKeys[i];
	fileUtil[key] = window.parentSandboxBridge[key];
}

fileUtil.getFilteredFileList = function(/*String*/startDir, 
		/*RegExp*/regExpFilter, /*boolean?*/makeUnixPaths,
		 /*boolean?*/startDirIsJavaObject){ 
	// getFilteredFileList is special-cased, because the RegExp object 
	// can't cross the sandbox bridge
	return window.parentSandboxBridge.getFilteredFileList(startDir,
		regExpFilter.source, makeUnixPaths, startDirIsJavaObject);
}


var readText = fileUtil.readFile;