dojo.provide("toolbox.IframeProxyPane");

dojo.require("dijit.layout._LayoutWidget");

dojo.declare("toolbox.IframeProxyPane", [dijit.layout._LayoutWidget], {
	src: "about:blank",
	buildRendering: function() {
		this.domNode = this.srcNodeRef;
		dojo.style(this.domNode, "overflow", "hidden");
		var css = "position:relative; top: 0; bottom: 0; width: 100%; border:none; margin: 0";
	 	iframe = dojo.doc.createElement("iframe");

		iframe.src = this.src;
		//iframe.className = "dijitBackgroundIframe";
		iframe.style.cssText = css;
		dojo.attr(iframe, {
			"name": this.id+"_win",
			"id": this.id+"_iframe",
		});
//		console.log("set src to: " + iframe.src);

		var pnode = this.domNode;
		while(pnode.firstChild) {
			pnode.removeChild(pnode.firstChild);
		}
		this.domNode.appendChild(iframe);
		this.iframe = iframe;
	},
	
	resize: function(box) {
		if(!box) {
			box = dojo.contentBox(this.domNode);
//			console.log("resize, domNode has box: " + dojo.toJson(box));
		}
		dojo.marginBox(this.iframe, box);
	},
	
	postCreate: function() {
		this.inherited(arguments);
		this.document = this._getWin().document;
	},
	
	_getWin: function() {
		return this.iframe.contentWindow;
	},
	
	setUrl: function(url) {
		this._getWin().location.href = url;
//		console.log("set iframe to url: " + url);
	}, 

	back: function() {
		apiModule.historyBack();
	},

	forward: function() {
		apiModule.historyForward();
	}, 

	getBody: function() {
	  return this._getWin().document.body;
	},

	getDocument: function(){
	  return this._getWin().document;
	},

	setContent: function(cont, callback) {
		var win = this._getWin();
		win.location.href="about:blank";
		setTimeout(function() {
			var doc = win.document;
			if(!doc.body) {
				doc.open();
				doc.write(
					'<html>' +
					'	<body>' +
					'	</body>' +
					'</html>'
				);
				doc.close();
			}
			dojo.html.set(doc.body, cont);
			callback();
 			}, 0);
	}
});
