dojo.provide("toolbox.Module");

dojo.require("dojox.storage.AirFileStorageProvider");
dojo.require("toolbox.utils");
dojo.require("toolbox.ActivityOverlay");

dojo.declare("toolbox.Module", null, {
	// moduleDirectory: air.File
	moduleDirectory: null,

	// storageDirectory: air.File
	storageDirectory: null,
	
	// moduleName: String
	moduleName: "",
	
	constructor: function(name, params) {
		this.moduleName = name.replace(/\s+/g, "");
		
		// set up a db storage provider, with the module's own db table
		var storage = new dojox.storage.AirFileStorageProvider();
		// kind of a quick hack to get all storage methods using this modules' name as namespace
		storage.DEFAULT_NAMESPACE = "module_"+this.moduleName;

		this.getStorage = function() {
			return storage;
		};

		console.log(this.moduleName + " being created");
		
		dojo.mixin(this, params || {});
		
		if(typeof this.storageDirectory == "string") {
			this.storageDirectory = air.File.applicationStorageDirectory.resolvePath(this.storageDirectory);
		}
	},
	
	postscript: function() {
		// this.init();
	},
	
	init: function() {
		// stub
	},
	
	open: function() {
		this.isOpen = true;
	},
	
	close: function() {
		this.isOpen = false;
		// is a module really "closed" when its window is closed? 
	},
	
	teardown: function() {
		// called on application exit
	},
	
	_createActivityWidget: function() {
			var activityWidget = this._activityWidget = dijit.byId("activityBox") || new toolbox.ActivityOverlay({ id: "activityBox" });
			dojo.body().appendChild(activityWidget.domNode);
			activityWidget.startup();
			return activityWidget;
	},
	showFatalError: function(err) {
		alert(err.message);
	},
	showActivity: function(msg, opts) {
		var updateProps = dojo.mixin({
			indeterminate: true
		}, opts || {});
		if(!msg) {
			msg = "Loading...";
		}
		var activityWidget = this._activityWidget || this._createActivityWidget();

		activityWidget.setMessage(msg);

		activityWidget.update(updateProps);
		if(!activityWidget.isShowing) {
			activityWidget.show();
		}
	},
	hideActivity: function(msg) {
		var activityWidget = dijit.byId("activityBox"); 
		if(activityWidget) {
			activityWidget.hide();
		}
	}
	// TODO: help system
	// Preferences api - use direct property access or a store? 
	// TODO: notifications (to/from toolbox host app)

	
});