dojo.provide("toolbox.ModulePane"); 

dojo.declare("toolbox.ModulePane", [dijit.layout._LayoutWidget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("toolbox", "resources/ModulePane.html"),
	id: "",
	itemId: "",
	title: "Untitled",
	name: "",
	href: dojo.moduleUrl("toolbox", "resources/loading.html"),
	startUrl: "",
	iconSrc: dojo.moduleUrl("toolbox", "resources/defaultToolIcon.png"),
	closable: false,
	isOpen: false,
	// a default size for all modules
	initialWidth: 775, 
	initialHeight: 575,

	postMixInProperties: function() {
		this.inherited(arguments);
		var proto = dojo.getObject(this.declaredClass).prototype; 
		
		if(this.name && this.title === proto.title) {
			this.name = this.title;
		}
		if(!this.itemId && this.id) {
			this.itemId = this.id;
		}
		if(this.startUrl) {
			this.href= this.startUrl;
		}
		this._viewSize = {
			h: this.initialHeight, w: this.initialWidth
		}
	},

	show: function(args){

		if(this._window){ return; /* FAIL */ }

		var options = new air.NativeWindowInitOptions(); 
		var w = this._viewSize.w,
			h = this._viewSize.h;

		var windowBounds = new air.Rectangle(
			( air.Capabilities.screenResolutionX - w ) / 2,
			( air.Capabilities.screenResolutionY - h ) / 2,
			w, h
		);

		var deferredShowWindow = new dojo.Deferred(); 
		deferredShowWindow.addCallback(dojo.hitch(this, function() {	
			this._window  = air.HTMLLoader.createRootWindow(true, options, true, windowBounds);
			this._window.window.runtime = window.runtime; 
			this._window.window.commandLine = args;
			this._window.load( new air.URLRequest("app:/modules/" + this.id + "/" + this.id + ".html") );
			dojo.connect(this._window.window.nativeWindow,"close", this, function(e){
				delete this._window;
			});
			this._window.window.nativeWindow.activate();
	
		}));

		var button = app.btnlist.pane2button[this];

		// do some animation action, then activate
		// explode a div to the dialogs posn/dimensions
		var explodeNode = dojo.doc.createElement("div");
		explodeNode.className = "explodeNode";
		var originBox = dojo.coords(button.domNode);
		//	console.log(dojo.toJson(originBox));

		// create and place the explode node
		explodeNode.id = "xplode";
		dojo.style(explodeNode,{
			height:"10px",
			width:"10px",
			zIndex:100,
			postion:"absolute"
		});

		var endBox = { 
			t: windowBounds.top, 
			l: windowBounds.left, 
			w: windowBounds.width, 
			h: windowBounds.height 
		}; 

		var startBox = { 
				t: -5 + originBox.y + (originBox.h /2), 
				l: 5 + originBox.x + originBox.w, 
				w: 10, 
				h: 10
		}; 

		dojo.style(explodeNode, {
			top:  startBox.t +"px",
			left: startBox.l  + "px"
		})
		this._explodeNode = dojo.body().appendChild(explodeNode);
		console.log("added explodeNode at: " + explodeNode.style.top + ", " + explodeNode.style.left);

		deferredShowWindow.addCallback(dojo.hitch(this, function() {
			dojo.body().removeChild(this._explodeNode);
			delete this._explodeNode;
		}));

		var fadeIn = this._showAnim;
		var self = this;
		this._showAnim = dojo.fx.chain([
			// grow it out to the {right} and full width
			// grow it out to full height
			// animate by first growing in the box, then fading in the image

			dojo.animateProperty({
				node: explodeNode,
				duration: 250,
				properties: {
					width: { start: startBox.w, end: endBox.w },
					left: { start: startBox.l, end: endBox.l }
				}
			}), 
	
			dojo.animateProperty({
				node: explodeNode,
				duration: 350,
				properties: {
					height: { start: startBox.h, end: endBox.h },
					top: { start: startBox.t, end: endBox.t }
				}, 
				onEnd: function() {
					deferredShowWindow.callback();
				}
			})
	
		]); 
		this._showAnim.play();
		
	},

	hide: function() {
		this.domNode.style.display = "none";
	},
	 
	contentLoaded: function() {
		console.log("content is finished loading in my iframe");
	}
	
});